Bug 1261019 - Review Request: opennlp - A machine learning based toolkit for the processing of natural language text
Review Request: opennlp - A machine learning based toolkit for the processing...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michael Cronenworth
Fedora Extras Quality Assurance
:
Depends On: 1261017
Blocks: 1146661
  Show dependency treegraph
 
Reported: 2015-09-08 08:39 EDT by gil cattaneo
Modified: 2015-10-09 11:32 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-10-09 11:32:22 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mike: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description gil cattaneo 2015-09-08 08:39:26 EDT
Spec URL: https://gil.fedorapeople.org/opennlp.spec
SRPM URL: https://gil.fedorapeople.org/opennlp-1.5.3-1.fc22.src.rpm
Description:
The Apache OpenNLP library is a machine learning based toolkit for the
processing of natural language text.

It supports the most common NLP tasks, such as tokenization, sentence
segmentation, part-of-speech tagging, named entity extraction, chunking,
parsing, and coreference resolution. These tasks are usually required to
build more advanced text processing services. OpenNLP also includes
maximum entropy and perceptron based machine learning.

Fedora Account System Username: gil

Apache Tika 1.10 Build/Requires
Comment 1 Michael Cronenworth 2015-10-01 00:42:33 EDT
==ISSUES==
* MUST: Sub-package maxent does not include license text. Either provide it or place a Requires: on a package that does. Uima requires -tools so that sub-package is OK.
  http://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Subpackage_Licensing
* MUST: Fix unowned directories.
* MUST: pom.xml files are not installed.
* Version 1.6.0 has been released.
* Licenses found: "Unknown or generated". 2 files have unknown license.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Apache (v2.0)". 2 files
     have unknown license. Detailed output of licensecheck in
     /home/michael/Temp/1261019-opennlp/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/maven-poms/opennlp,
     /usr/share/java/opennlp
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/maven-poms/opennlp,
     /usr/share/java/opennlp
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 3 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[!]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in opennlp-
     tools , opennlp-maxent , opennlp-uima , opennlp-javadoc
[x]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: opennlp-1.5.3-1.fc22.noarch.rpm
          opennlp-tools-1.5.3-1.fc22.noarch.rpm
          opennlp-maxent-1.5.3-1.fc22.noarch.rpm
          opennlp-uima-1.5.3-1.fc22.noarch.rpm
          opennlp-javadoc-1.5.3-1.fc22.noarch.rpm
          opennlp-1.5.3-1.fc22.src.rpm
opennlp.noarch: W: spelling-error %description -l en_US tokenization -> ionization
opennlp.noarch: W: spelling-error %description -l en_US chunking -> chinking, clunking, chucking
opennlp.noarch: W: spelling-error %description -l en_US coreference -> co reference, co-reference, conference
opennlp.noarch: W: spelling-error %description -l en_US perceptron -> perception, Percheron
opennlp-tools.noarch: W: no-documentation
opennlp-maxent.noarch: W: no-documentation
opennlp-uima.noarch: W: no-documentation
opennlp.src: W: spelling-error %description -l en_US tokenization -> ionization
opennlp.src: W: spelling-error %description -l en_US chunking -> chinking, clunking, chucking
opennlp.src: W: spelling-error %description -l en_US coreference -> co reference, co-reference, conference
opennlp.src: W: spelling-error %description -l en_US perceptron -> perception, Percheron
6 packages and 0 specfiles checked; 0 errors, 11 warnings.




Rpmlint (installed packages)
----------------------------
opennlp-maxent.noarch: W: no-documentation
opennlp-uima.noarch: W: no-documentation
opennlp.noarch: W: spelling-error %description -l en_US tokenization -> ionization
opennlp.noarch: W: spelling-error %description -l en_US chunking -> chinking, clunking, chucking
opennlp.noarch: W: spelling-error %description -l en_US coreference -> co reference, co-reference, conference
opennlp.noarch: W: spelling-error %description -l en_US perceptron -> perception, Percheron
opennlp-tools.noarch: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 7 warnings.



Requires
--------
opennlp-maxent (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils

opennlp-uima (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.opennlp:opennlp-tools)

opennlp-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

opennlp (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(org.apache.maven.plugins:maven-compiler-plugin)
    mvn(org.apache:apache:pom:)

opennlp-tools (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(net.sf.jwordnet:jwnl)
    mvn(org.apache.opennlp:opennlp-maxent)



Provides
--------
opennlp-maxent:
    mvn(org.apache.opennlp:opennlp-maxent)
    mvn(org.apache.opennlp:opennlp-maxent:pom:)
    opennlp-maxent
    osgi(org.apache.opennlp.maxent)

opennlp-uima:
    mvn(org.apache.opennlp:opennlp-uima)
    mvn(org.apache.opennlp:opennlp-uima:pom:)
    opennlp-uima

opennlp-javadoc:
    opennlp-javadoc

opennlp:
    mvn(org.apache.opennlp:opennlp:pom:)
    opennlp

opennlp-tools:
    mvn(org.apache.opennlp:opennlp-tools)
    mvn(org.apache.opennlp:opennlp-tools:pom:)
    opennlp-tools
    osgi(org.apache.opennlp.tools)



Source checksums
----------------
http://www.apache.org/dist/opennlp/opennlp-1.5.3/apache-opennlp-1.5.3-src.tar.gz :
  CHECKSUM(SHA256) this package     : 792d0a3cc221400403f2a05a65fa642d55f0a8d2a6462aac354e9b7b6800b266
  CHECKSUM(SHA256) upstream package : 792d0a3cc221400403f2a05a65fa642d55f0a8d2a6462aac354e9b7b6800b266


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1261019 -L jwnl
Buildroot used: fedora-22-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Built with local dependencies:
    /home/michael/Temp/jwnl/jwnl-javadoc-1.4-0.1.rc3.fc24.noarch.rpm
    /home/michael/Temp/jwnl/jwnl-1.4-0.1.rc3.fc24.noarch.rpm
Comment 2 gil cattaneo 2015-10-01 05:25:42 EDT
(In reply to Michael Cronenworth from comment #1)
> ==ISSUES==
> * MUST: Sub-package maxent does not include license text. Either provide it
> or place a Requires: on a package that does. Uima requires -tools so that
> sub-package is OK.
Require list are managed by our java tools

> http://fedoraproject.org/wiki/Packaging:
> LicensingGuidelines#Subpackage_Licensing
> * MUST: Fix unowned directories.
idem for this
> * MUST: pom.xml files are not installed.
idem for this
> * Version 1.6.0 has been released.
for the moment i prefer import this release.
I will update when it will be necessary.
> * Licenses found: "Unknown or generated". 2 files have unknown license.

Plaese, review also this https://bugzilla.redhat.com/show_bug.cgi?id=1261017
Comment 3 gil cattaneo 2015-10-01 05:38:21 EDT
Note: run fedora-review -b [BUG NUMBER] --plugins Java -m fedora-rawhide-[YOUR PREFERRED ARCH]
and install fedora-review-plugin-java package to get a more comprehensive java review

Spec URL: https://gil.fedorapeople.org/opennlp.spec
SRPM URL: https://gil.fedorapeople.org/opennlp-1.5.3-2.fc22.src.rpm

- add license and notice files in maxent subpackage
Comment 4 Michael Cronenworth 2015-10-01 09:58:16 EDT
@gil, I know what I'm doing. Please see the fedora-review output:

> Active plugins: Generic, Shell-api, Java

(In reply to gil cattaneo from comment #2)
> Require list are managed by our java tools

I understand that. I was not requesting you add any unnecessary Requires. You have fixed this issue. Thanks.

> > * MUST: Fix unowned directories.
> idem for this

Your java tools are not pulling in the directories. They are not being owned.

> > * MUST: pom.xml files are not installed.
> idem for this

idem

> > * Version 1.6.0 has been released.
> for the moment i prefer import this release.

OK.

> Plaese, review also this https://bugzilla.redhat.com/show_bug.cgi?id=1261017

OK.
Comment 5 Michael Cronenworth 2015-10-01 10:08:01 EDT
> > > * MUST: pom.xml files are not installed.
> > idem for this

I see the fedora-review check doesn't see the files have been renamed to "opennlp.pom", etc. You may ignore this one.

The only outstanding issue is the unowned directories.
Comment 6 gil cattaneo 2015-10-01 11:18:11 EDT
(In reply to Michael Cronenworth from comment #5)
> > > > * MUST: pom.xml files are not installed.
> > > idem for this
> 
> I see the fedora-review check doesn't see the files have been renamed to
> "opennlp.pom", etc. You may ignore this one.
> 
> The only outstanding issue is the unowned directories.
This would not be necessary if you knew the
latest featrues of javapackages-tools (F23 and rawhide).
if i owned:
/usr/share/maven-poms/opennlp
/usr/share/java/opennlp
they become only duplicate files / directories
Comment 7 Michael Cronenworth 2015-10-01 12:34:43 EDT
If you have no plans to ship a F21 / F22 package, OK, but I imagine you will.

If the new Java package tools will not be shipped for F21/F22 you will need to carry a if block for them.

%if 0%{?fedora} < 23
/usr/share/maven-poms/opennlp
/usr/share/java/opennlp
%endif
Comment 8 gil cattaneo 2015-10-01 12:42:25 EDT
(In reply to Michael Cronenworth from comment #7)
> If you have no plans to ship a F21 / F22 package, OK, but I imagine you will.
this package is only for F23 and rawhide
Comment 9 Michael Cronenworth 2015-10-01 12:43:41 EDT
Fair enough.

APPROVED
Comment 10 gil cattaneo 2015-10-01 12:55:21 EDT
New Package SCM Request
=======================
Package Name: opennlp
Short Description: A machine learning based toolkit for the processing of natural language text
Upstream URL: https://opennlp.apache.org/
Owners: gil
Branches: f23
InitialCC: java-sig
Comment 11 Gwyn Ciesla 2015-10-02 07:23:30 EDT
Git done (by process-git-requests).
Comment 12 Fedora Update System 2015-10-02 11:22:36 EDT
opennlp-1.5.3-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-d535f8eecf
Comment 13 Fedora Update System 2015-10-03 21:51:26 EDT
opennlp-1.5.3-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update opennlp'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-d535f8eecf
Comment 14 Fedora Update System 2015-10-09 11:32:20 EDT
opennlp-1.5.3-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.